#ifndef _CHIP_8_H_
#define _CHIP_8_H_

#include <stdint.h>

#define STACK_SIZE 0xF+1

struct Chip8
{
    uint8_t     memory[0xFFF+1];
    uint8_t     regist[0xF+1];
    uint16_t    stack[STACK_SIZE];
    uint16_t    PC; //program counter
    uint16_t    I;  //Special register
    uint8_t     SP; //Stack pointer
    uint8_t     DT; //Delay timer
    uint8_t     ST; //Sound timer
    uint64_t    vram[32];//waiting for c21 and uint128_t for big screen :3c
};


#endif //_CHIP_8_H_
